<template>
  <v-dialog :value="has" persistent max-width="480px">
    <v-card>
      <v-app-bar dense color="primary">
        <v-app-bar-title class="white--text">
          Whoops! :(
        </v-app-bar-title>
        <v-spacer></v-spacer>
        <v-btn small icon @click="clear" color="white">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-app-bar>
      <v-card-text class="pb-0">
        <v-container fluid class="mt-1">
          <v-row no-gutters>
            <v-col cols="12" v-for="error of errors" :key="error.message">
              <v-alert dense type="error" :key="error.message">
                <template v-if='error.code' v-slot:default>
                  <insufficient-balance v-if='error.code' :code='error.code'/>
                </template>
                <template v-else>
                  <p>{{ error.message }} {{error.code}}</p>
                </template>
                <template v-slot:close>
                  <v-icon dense @click="close(error)">mdi-close</v-icon>
                </template>
              </v-alert>
            </v-col>
          </v-row>
          <v-row dense class='mt-0'>
            <v-col cols='12'>
              <v-btn block color='primary' @click='clear'>Закрыть</v-btn>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { DialogError } from '@/store/module/errors';
import InsufficientBalance from '@/components/errors/InsufficientBalance.vue';

@Component({
  components: {
    InsufficientBalance
  }
})
export default class ErrorsDialog extends Vue {
  private get errors(): DialogError[] {
    return this.$store.getters['errors/items'];
  }

  private get has(): boolean {
    return this.$store.getters['errors/has'];
  }

  private async close(error: DialogError): Promise<void> {
    this.$store.commit('errors/remove', error);
  }

  private async clear(): Promise<void> {
    this.$store.commit('errors/clear');
  }
}
</script>

<style scoped></style>
